<?php
/**
 * @filename DefaultFactory.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:48
 */


namespace JerryYan\DSL\Token\Factory;


use JerryYan\DSL\Token\Token;
use JerryYan\DSL\Token\TokenAnd;
use JerryYan\DSL\Token\TokenOr;
use JerryYan\DSL\Token\TokenVar;

class DefaultFactory extends FactoryInterface
{
    protected $tokenMap = [
        Token::AND => TokenAnd::class,
        Token::OR => TokenOr::class,
        Token::VAR => TokenVar::class,
    ];

    protected $tokenNameMap = [
        "和" => Token::AND,
        "或者" => Token::OR,
        "或" => Token::OR,
    ];

    protected $undefinedTokenClass = TokenVar::class;
}